// VideoCreator.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "VideoCreator.h"
#include "createvideo.h"

#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;
#ifdef COMPRESSION
	int keyframe;
#endif

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
#ifdef COMPRESSION
	  if (argc != 9) {
#else
	  if (argc != 8) {
#endif
	    cout << "There are seven parameters required" << endl;
	    cout << argv[0] << " Basename Suffix Digits Start Number";
#ifdef COMPRESSION
	    cout << " Keyframe";
#endif
	    cout << " Framerate Output" <<endl;
	    cout << "Basename: base filename including path if necessary" << endl;
	    cout << "Suffix: suffix of image files (usually .bmp but could be longer/more complicated as well)" << endl;
	    cout << "Digits: number of digits used to number the files" << endl;
	    cout << "Start: number of frame to start with" << endl;
	    cout << "Number: number of frames (so frames should be numbered start through start+number-1)" << endl;
#ifdef COMPRESSION
	    cout << "Keyframe: key frame should be placed every x frames" << endl;
#endif
	    cout << "Framerate: frame rate of the resulting movie" << endl;
	    cout << "Output: output file name" << endl;
	    exit (1);
	  }

#ifdef COMPRESSION
	  int framerate = strtol (argv[7], 0, 10);
	  int keyframe = strtol (argv[6], 0, 10);
#else
	  int framerate = strtol (argv[6], 0, 10);
#endif
	  int start = strtol (argv[4], 0, 10);
	  int max = strtol (argv[5], 0, 10);
	  int digits = strtol (argv[3], 0, 10);
	  createvideo (argv[1],
		       argv[2],
		       digits,
		       start,
		       max,
#ifdef COMPRESSION
		       keyframe,
#endif
		       framerate,
#ifdef COMPRESSION
		       argv[8]);
#else
		       argv[7]);
#endif
	}

	return nRetCode;
}


